#include <Losant.h>
#include <WiFi.h>
#include <WebServer.h>
#include <WiFiClient.h>
#include <Update.h>

String html_otaPage = 
"<form method='POST' action='' enctype='multipart/form-data' id='upload_form'>"
"<input type='file' name='update'>"
"<input type='submit' value='Update'>"
"<div id='prg'>0%</div>"
"</form>"
"<script>"
"var form = document.getElementById('upload_form');"
"form.addEventListener('submit', upload);"
"function upload (e)"
"{"
"e.preventDefault();"
"var form = document.getElementById('upload_form');"
"var par = document.getElementById('prg');"
"var data = new FormData(form);"
"var xhr = new XMLHttpRequest();"
"xhr.open('POST', '/update');"
"xhr.upload.onprogress = function(evt) {"
"if (evt.lengthComputable) {"
"var per = evt.loaded / evt.total;"
"par.textContent = ('Running ' + Math.round(per*100) + '%');"
"}"
"};"
"xhr.send(data);"
"}"
"</script>";

char* ssid = "ssid";  // Enter SSID here
char* password = "password";  //Enter Password here

const char* LOSANT_DEVICE_ID = "617ac2bf183f1800073f440b";
const char* LOSANT_ACCESS_KEY = "d814b734-1d17-47e3-a7b9-e54804f29bc2";
const char* LOSANT_ACCESS_SECRET = "724edd683137fbee110fca3555f27112ed6f2ac7fdb637f39498807cf1746575";

WiFiClient wifiClient;
LosantDevice device(LOSANT_DEVICE_ID);

const char* assid = "ESP32";
const char* asecret = "12345678";

uint32_t oldTime;

WebServer server(80);

void setup() {
  // put your setup code here, to run once:

  //Connect to wifi
  //Serial.begin(115200, SERIAL_8N1);
  Serial.begin(115200, SERIAL_8N1, 16 ,17);
  Serial.printf("\n Got IP:"); Serial.print(WiFi.localIP());
  
  Serial.printf("\n Connecting to");
  Serial.printf(ssid);

  WiFi.mode(WIFI_AP);
  WiFi.softAP(assid, asecret);
  WiFi.begin(ssid, password);

  uint8_t connectCount = 0;
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.printf(".");
    connectCount++;
    if(connectCount >= 20)
      break;
  }
  if(connectCount == 20)
    Serial.printf("\n WiFi connect Fail!");
  else
    Serial.printf("\n WiFi connected!");

  //Connect to Losant
  device.onCommand(&handleCommand);
  device.connect(wifiClient, LOSANT_ACCESS_KEY, LOSANT_ACCESS_SECRET);
    
  Serial.printf("\n Connecting to Losant...");
  connectCount = 0;
  while (!device.connected()) {
    delay(500);
    Serial.printf(".");
    connectCount++;
    if(connectCount >= 20)
      break;
  }
  if(connectCount == 20)
    Serial.printf("Connected! Fail");
  else
    Serial.printf("Connected!");
  
  server.on("/ota", HTTP_GET, handle_OtaPage);
  server.on("/update", HTTP_POST, handle_OnUpdateDone, handle_OnUpdateStart);
  server.onNotFound(handle_NotFound);
  server.begin();

  oldTime = millis();
}

void loop() {
  // put your main code here, to run repeatedly:
  
  server.handleClient();
  device.loop();

  if(abs(oldTime - millis()) >= 1000)
  {
    oldTime = millis();
    Serial.printf("\n Send Data to Losant");
    StaticJsonDocument<200> jsonBuffer;
    JsonObject root = jsonBuffer.to<JsonObject>();
    root["tempC"] = 25;
    root["tempF"] = 77;
    device.sendState(root);
  }
}

void handleCommand(LosantCommand *command)
{
  Serial.print("Command received: ");
  Serial.println(command->name);
}

void handle_OtaPage()
{
  server.sendHeader("Connection", "close");
  server.send(200, "text/html", html_otaPage);
}

void handle_OnUpdateDone()
{
  server.sendHeader("Connection", "close");
  server.send(200, "text/plain", (Update.hasError()) ? "FAIL" : "OK");
  ESP.restart();
}

void handle_OnUpdateStart()
{
  HTTPUpload upload = server.upload();
  if (upload.status == UPLOAD_FILE_START) {
    if (!Update.begin(UPDATE_SIZE_UNKNOWN)) 
      Update.printError(Serial);
  } 
  else if (upload.status == UPLOAD_FILE_WRITE) 
  {
    if (Update.write(upload.buf, upload.currentSize) != upload.currentSize) 
      Update.printError(Serial);
  } 
  else if (upload.status == UPLOAD_FILE_END) {
    if (Update.end(true)) 
    {
      Serial.printf("Update Success: %u\nRebooting...\n", upload.totalSize);
    } 
    else 
    {
      Update.printError(Serial);
    }
  }
}

void handle_NotFound()
{
  
}
